;;; add Mule-UCS to load-path
(add-to-list 'load-path "/usr/share/emacs/site-lisp/Mule-UCS")

(let* ((locale (or (getenv "LC_ALL")
		   (getenv "LC_CTYPE")
		   (getenv "LANG")))
       (lang-region (and locale
			 (substring locale 0 (min 5 (length locale)))))
       (lang (and lang-region
		  (substring lang-region 0 (min 2 (length lang-region))))))
  (cond ((equal lang "ja")
	 (set-language-environment "Japanese"))
	((equal lang "ko")
	 (set-language-environment "Korean"))
	((equal lang-region "zh_CN")
	 (set-language-environment "Chinese-GB"))
	((equal lang-region "zh_TW")
	 (set-language-environment "Chinese-BIG5")))
  (cond ((equal locale-coding-system 'utf-8)
	 (when (member lang '("ja" "ko" "zh"))
	   ;; CJK utf-8 locale needs Mule-UCS
	   (require 'un-define))
	 (set-default-coding-systems 'utf-8)
	 (set-terminal-coding-system 'utf-8)
	 (let ((term (getenv "TERM")))
	   (when (or (string-match "^linux" term)
		     (string-match "^xterm" term))
	     (set-keyboard-coding-system 'utf-8))))
	((equal lang "ja")
	 (set-default-coding-systems 'euc-jp)
	 (set-terminal-coding-system 'euc-jp)
	 (set-keyboard-coding-system 'euc-jp))
	((equal lang "ko")
	 (set-default-coding-systems 'euc-kr)
	 (set-terminal-coding-system 'euc-kr)
	 (set-keyboard-coding-system 'euc-kr))
	((equal lang-region "zh_CN")
	 (set-default-coding-systems 'cn-gb-2312)
	 (set-terminal-coding-system 'cn-gb-2312)
	 (set-keyboard-coding-system 'cn-gb-2312))
	((equal lang-region "zh_TW")
	 (set-default-coding-systems 'big5)
	 (set-terminal-coding-system 'big5)
	 (set-keyboard-coding-system 'big5)))
  (when (member lang '("ja" "ko" "zh"))
    ;; ispell doesn't support CJK
    (setq-default ispell-local-dictionary "english")))
